/**************************************************************************************************
           .
      "".     cab-.
Cab-  ,        .
:         ,  
"WHERE"   .
**************************************************************************************************/
DECLARE
@DataBaseName SYSNAME, --     (  )
@BackUpPath SYSNAME, --    bak-     
@CabPath SYSNAME, --    cab-     
@DirPath SYSNAME, --        
@FSO INT, --   OLE- "Scripting.FileSystemObject"
@BackUpSuffix SYSNAME, --     bak-  cab- ,   
@year varchar (4), @month varchar (2), @day varchar (2) -- ,        

-->>**************************************************************************************
--       :
SET @DirPath = 'X:\MyBackups\'
--<<**************************************************************************************

--   "Scripting.FileSystemObject"   bak-   :
EXEC sp_OACreate "Scripting.FileSystemObject", @FSO OUT

--     ,   :
SET @year = CAST(DATEPART(Year, GetDate()) AS varchar)
SET @month = CAST(DATEPART(Month, GetDate()) AS varchar)
SET @day = CAST(DATEPART(Day, GetDate()) AS varchar)
EXEC xp_sprintf @BackUpSuffix OUTPUT, '%04s%02s%02s', @year, @month, @day

--        :
DECLARE Step_cursor CURSOR FOR SELECT [Name] FROM master..sysdatabases WHERE [Name]<>'tempdb'
OPEN Step_cursor
FETCH NEXT FROM Step_cursor INTO @DataBaseName
WHILE @@FETCH_STATUS = 0 BEGIN
    --    bak-  cab-:
    SET @BackUpPath = @DirPath + @DataBaseName + @BackUpSuffix + '.bak'
    SET @CabPath = @DirPath + @DataBaseName + @BackUpSuffix + '.cab'
    --     ( bak-):
    BACKUP DATABASE @DataBaseName TO DISK = @BackUpPath WITH INIT
    --  bak- ( cab-):
    EXEC master..xp_makecab @CabPath, 'mszip', 0, @BackUpPath
    --  bak-   :
    EXEC sp_OAMethod @FSO, 'DeleteFile', NULL, @BackUpPath

    FETCH NEXT FROM Step_cursor INTO @DataBaseName
END
CLOSE Step_cursor
DEALLOCATE Step_cursor
--   "Scripting.FileSystemObject":
EXEC sp_OADestroy @FSO